.. meta::
   :description: a collection of known design patterns along with implementations in PHP8
   :keywords: design patterns, php, best practices

.. DesignPatternsPHP

=================
DesignPatternsPHP
=================

.. image:: https://github.com/domnikl/DesignPatternsPHP/workflows/CI/badge.svg
   :target: https://github.com/domnikl/DesignPatternsPHP/actions
   :alt: Build Status

.. image:: https://readthedocs.org/projects/designpatternsphp/badge/?version=latest
   :target: https://readthedocs.org/projects/designpatternsphp/?badge=latest
   :alt: Documentation Status

.. image:: https://img.shields.io/badge/donate-paypal-blue.svg?style=flat-square
   :target: https://paypal.me/magdyabass
   :alt: Donate

This is a collection of known design patterns and some sample code how
to implement them in PHP. Every pattern has a small list of examples.

I think the problem with patterns is that often people do know them but
don't know when to apply which.

Patterns
--------

The patterns can be structured in roughly three different categories.
Please click on **the title of every pattern's page** for a full explanation of the pattern on Wikipedia.

.. toctree::
   :titlesonly:
   :numbered:

   Creational/README
   Structural/README
   Behavioral/README
   More/README
